Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QCoreApplication

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QObject
                      com.trolltech.qt.core.QCoreApplication

All Implemented Interfaces:
  QtJambiInterface

Direct Known Subclasses:
  QApplication

    public class QCoreApplication

extends QObject

The `QCoreApplication` class provides an event loop for console Qt applications. This class is used by non-GUI applications to provide their event loop. For non-GUI application that uses Qt, there should be exactly one `QCoreApplication` object. For GUI applications, see `QApplication`.

`QCoreApplication` contains the main event loop, where all events from the operating system (e.g., timer and network events) and other sources are processed and dispatched. It also handles the application's initialization and finalization, as well as system-wide and application-wide settings.

The command line arguments which `QCoreApplication`'s constructor should be called with are accessible using `arguments()`. The event loop is started with a call to `exec()`. Long running operations can call `processEvents()` to keep the application responsive.

Some Qt classes, such as QString, can be used without a `QCoreApplication` object. However, in general, we recommend that you create a `QCoreApplication` or a `QApplication` object in your `main()` function as early as possible. The application will enter the event loop when `exec()` is called. `exit()` will not return until the event loop exits, e.g., when `quit()` is called.

An application has an `applicationDirPath()` and an `applicationFilePath()`. Translation files can be added or removed using `installTranslator()` and `removeTranslator()`. Application strings can be translated using `translate()`. The QObject::tr() and QObject::trUtf8() functions are implemented in terms of `translate()`.

The class provides a `quit()` slot and an `aboutToQuit()` signal.

Several static convenience functions are also provided. The `QCoreApplication` object is available from `instance()`. Events can be sent or posted using `sendEvent()`, `postEvent()`, and `sendPostedEvents()`. Pending events can be removed with `removePostedEvents()` or flushed with `flush()`. Library paths (see QLibrary) can be retrieved with `libraryPaths()` and manipulated by `setLibraryPaths()`, `addLibraryPath()`, and `removeLibraryPath()`.

See also:
  `QApplication`, `QAbstractEventDispatcher`, `QEventLoop`, Semaphores Example, and Wait Conditions Example.

Nested Class Summary
`static class` | `QCoreApplication.Encoding` Also, for all encodings except `QTextStream::Latin1` and QTextStream::UTF8, you need to call setAutoDetectUnicode(false) to obtain the Qt 3 behavior in addition to the `setCodec()` call.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary
`QSignalEmitter.Signal0` | `aboutToQuit` This signal is emitted when the application is about to quit the main event loop, e.
`protected static QCoreApplication` | `m_instance`
`QSignalEmitter.Signal1` | `unixSignal` This signal takes 1 generic argument(s).

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QCoreApplication(java.lang.String[] args)` Constructs a Qt kernel application.

Method Summary
`static void` | `addLibraryPath(java.lang.String arg__1)` Prepends `path` to the end of the library path list.
`static java.lang.String` | `applicationDirPath()` Returns the directory that contains the application executable.
`static java.lang.String` | `applicationFilePath()` Returns the file path of the application executable.
`static java.lang.String` | `applicationName()` This property holds the name of this application.
`static long` | `applicationPid()` Returns the current process ID for the application.
`static java.lang.String` | `applicationVersion()` This property holds the version of this application.
`static java.util.List` | `arguments()` Returns the list of command-line arguments.
`static boolean` | `closingDown()` Returns true if the application objects are being destroyed; otherwise returns false.
`static int` | `exec()` Enters the main event loop and waits until `exit()` is called.
`static void` | `exit()` Tells the application to exit with a return code.
`static void` | `exit(int retcode)` Tells the application to exit with a return code.
`static void` | `flush()` Flushes the platform specific event queues.
`static boolean` | `hasPendingEvents()` This function returns true if there are pending events; otherwise returns false.
`static void` | `initialize(java.lang.String[] args)` QCoreApplication keeps a unique instance of a QCoreApplication.
`static void` | `installTranslator(QTranslator messageFile)` Adds the translation file `translationFile` to the list of translation files to be used for translations.
`static QCoreApplication` | `instance()` Returns a pointer to the application's `QCoreApplication` (or `QApplication`) instance.
`static void` | `invokeAndWait(java.lang.Runnable runnable)` Executes the runnable's run() method in the main thread and waits for it to return.
`static void` | `invokeLater(int timeout, java.lang.Runnable task)` Executes the task in the application's main thread after the specified timeout.
`static void` | `invokeLater(java.lang.Runnable runnable)` This function will queue the `runnable` and invokes it later.
`static java.util.List` | `libraryPaths()` Returns a list of paths that the application will search when dynamically loading libraries.
`boolean` | `notify(QObject arg__1, QEvent arg__2)` Sends `event` to `receiver`.
`static java.lang.String` | `organizationDomain()` This property holds the Internet domain of the organization that wrote this application.
`static java.lang.String` | `organizationName()` This property holds the name of the organization that wrote this application.
`static void` | `postEvent(QObject receiver, QEvent event)` Adds the event `event`, with the object `receiver` as the receiver of the event, to an event queue and returns immediately.
`static void` | `postEvent(QObject receiver, QEvent event, int priority)` Adds the event `event`, with the object `receiver` as the receiver of the event, to an event queue and returns immediately.
`static void` | `processEvents()` Processes all pending events for the calling thread according to the specified `flags` until there are no more events to process.
`static void` | `processEvents(QEventLoop.ProcessEventsFlag[] flags)` Processes all pending events for the calling thread according to the specified `flags` until there are no more events to process.
`static void` | `processEvents(QEventLoop.ProcessEventsFlags flags)` Processes all pending events for the calling thread according to the specified `flags` until there are no more events to process.
`static void` | `processEvents(QEventLoop.ProcessEventsFlags flags, int maxtime)` Processes pending events for the calling thread for `maxtime` milliseconds or until there are no more events to process, whichever is shorter.
`static void` | `quit()` Tells the application to exit with return code 0 (success).
`static void` | `removeLibraryPath(java.lang.String arg__1)` Removes `path` from the library path list.
`static void` | `removePostedEvents(QObject receiver)` Removes all events posted using `postEvent()` for `receiver`.
`static void` | `removePostedEvents(QObject receiver, int eventType)` Removes all events of the given `eventType` that were posted using `postEvent()` for `receiver`.
`static void` | `removeTranslator(QTranslator messageFile)` Removes the translation file `translationFile` from the list of translation files used by this application.
`static boolean` | `sendEvent(QObject receiver, QEvent event)` Sends event `event` directly to receiver `receiver`, using the `notify()` function.
`static void` | `sendPostedEvents()` Dispatches all posted events, i.e.
`static void` | `sendPostedEvents(QObject receiver, int event_type)` Immediately dispatches all events which have been previously queued with `QCoreApplication::postEvent()` and which are for the object `receiver` and have the event type `event_type`.
`static void` | `setApplicationName(java.lang.String application)` This property holds the name of this application.
`static void` | `setApplicationVersion(java.lang.String version)` This property holds the version of this application.
`static void` | `setAttribute(Qt.ApplicationAttribute attribute)` Sets the attribute `attribute` if `on` is true; otherwise clears the attribute.
`static void` | `setAttribute(Qt.ApplicationAttribute attribute, boolean on)` Sets the attribute `attribute` if `on` is true; otherwise clears the attribute.
`static void` | `setLibraryPaths(java.util.List arg__1)` Sets the list of directories to search when loading libraries to `paths`.
`static void` | `setOrganizationDomain(java.lang.String orgDomain)` This property holds the Internet domain of the organization that wrote this application.
`static void` | `setOrganizationName(java.lang.String orgName)` This property holds the name of the organization that wrote this application.
`static boolean` | `startingUp()` Returns true if an application object has not been created yet; otherwise returns false.
`static boolean` | `testAttribute(Qt.ApplicationAttribute attribute)` Returns true if attribute `attribute` is set; otherwise returns false.
`static java.lang.String` | `translate(java.lang.String context, java.lang.String sourceText)` This is an overloaded function provided for convenience.
`static java.lang.String` | `translate(java.lang.String context, java.lang.String sourceText, java.lang.String comment)` Returns the translation text for `sourceText`, by querying the installed translation files.
`static java.lang.String` | `translate(java.lang.String context, java.lang.String sourceText, java.lang.String comment, int n)` Returns the translation text for `sourceText`, by querying the installed translation files.

Methods inherited from class com.trolltech.qt.core.QObject
`childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, event, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, indexOfProperty, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, properties, property, removeEventFilter, setObjectName, setParent, setProperty, startTimer, timerEvent, toString, userProperty`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### aboutToQuit

    public final QSignalEmitter.Signal0 aboutToQuit

  This signal is emitted when the application is about to quit the main event loop, e. . when the event loop level drops to zero. This may happen either after a call to `quit()` from inside the application or when the users shuts down the entire desktop session.

  The signal is particularly useful if your application has to do some last-second cleanup. Note that no user interaction is possible in this state.

See also:
  `quit()`.

### unixSignal

    public final QSignalEmitter.Signal1 unixSignal

  This signal takes 1 generic argument(s). We list their type and the name they go by in the description of this signal. <java.lang.Integer(named: number)>:

  This signal is emitted whenever a Unix signal is received by the application. The Unix signal received is specified by its `number`.

### m_instance

    protected static QCoreApplication m_instance

Constructor Detail

### QCoreApplication

    public QCoreApplication(java.lang.String[] args)

  Constructs a Qt kernel application. Kernel applications are applications without a graphical user interface. These type of applications are used at the console or as server processes.

  The argument `args` arguments are processed by the application, and made available in a more convenient form by the `arguments()` function.

Method Detail

### notify

    public boolean notify(QObject arg__1,
                          QEvent arg__2)

  Sends `event` to `receiver`. `receiver`->event(`event`). Returns the value that is returned from the receiver's event handler.

  For certain types of events (e.g. mouse and key events), the event will be propagated to the receiver's parent and so on up to the top-level object if the receiver is not interested in the event (i.e., it returns false).

  There are five different ways that events can be processed; reimplementing this virtual function is just one of them. All five approaches are listed below:

  1. Reimplementing paintEvent(), mousePressEvent() and so on. This is the commonest, easiest and least powerful way.
  2. Reimplementing this function. This is very powerful, providing complete control; but only one subclass can be active at a time.
  3. Installing an event filter on `QCoreApplication::instance()`. Such an event filter is able to process all events for all widgets, so it's just as powerful as reimplementing `notify()`; furthermore, it's possible to have more than one application-global event filter. Global event filters even see mouse events for `disabled widgets`.
  4. Reimplementing `QObject::event()` (as `QWidget` does). If you do this you get Tab key presses, and you get to see the events before any widget-specific event filters.
  5. Installing an event filter on the object. Such an event filter gets all the events except Tab and Shift-Tab key presses.

See also:
  `QObject::event()`, and `installEventFilter()`.

### addLibraryPath

    public static void addLibraryPath(java.lang.String arg__1)

  Prepends `path` to the end of the library path list. If `path` is empty or already in the path list, the path list is not changed.

  The default path list consists of a single entry, the installation directory for plugins. The default installation directory for plugins is `INSTALL/plugins`, where `INSTALL` is the directory where Qt was installed.

See also:
  `removeLibraryPath()`, `libraryPaths()`, and `setLibraryPaths()`.

### applicationDirPath

    public static java.lang.String applicationDirPath()

  Returns the directory that contains the application executable.

  For example, if you have installed Qt in the `C:\Trolltech\Qt` directory, and you run the `regexp` example, this function will return "C:/Trolltech/Qt/examples/tools/regexp".

  On Mac OS X this will point to the directory actually containing the executable, which may be inside of an application bundle (if the application is bundled).

  Warning: On Unix, this function assumes that argv[0] contains the file name of the executable (which it normally does). It also assumes that the current directory hasn't been changed by the application.

See also:
  `applicationFilePath()`.

### applicationFilePath

    public static java.lang.String applicationFilePath()

  Returns the file path of the application executable.

  For example, if you have installed Qt in the `/usr/local/qt` directory, and you run the `regexp` example, this function will return "/usr/local/qt/examples/tools/regexp/regexp".

  Warning: On Unix, this function assumes that argv[0] contains the file name of the executable (which it normally does). It also assumes that the current directory hasn't been changed by the application.

See also:
  `applicationDirPath()`.

### applicationName

    public static java.lang.String applicationName()

  This property holds the name of this application. The value is used by the `QSettings` class when it is constructed using the empty constructor. This saves having to repeat this information each time a `QSettings` object is created.

See also:
  `organizationName`, `organizationDomain`, and `applicationVersion`.

### applicationPid

    public static long applicationPid()

  Returns the current process ID for the application.

### applicationVersion

    public static java.lang.String applicationVersion()

  This property holds the version of this application.

See also:
  `applicationName`, `organizationName`, and `organizationDomain`.

### arguments

    public static java.util.List arguments()

  Returns the list of command-line arguments.

  `arguments()`.at(0) is the program name, `arguments()`.at(1) is the first argument, and `arguments()`.last() is the last argument.

  Calling this function is slow - you should store the result in a variable when parsing the command line.

  Warning: On Unix, this list is built from the argc and argv parameters passed to the constructor in the main() function. The string-data in argv is interpreted using QString::fromLocal8Bit(); hence it is not possible to pass i.e. Japanese command line arguments on a system that runs in a latin1 locale. Most modern Unix systems do not have this limitation, as they are Unicode based.

  On NT-based Windows, this limitation does not apply either. On Windows, the `arguments()` are not built from the contents of argv/argc, as the content does not support Unicode. Instead, the `arguments()` are constructed from the return value of GetCommandLine().

### closingDown

    public static boolean closingDown()

  Returns true if the application objects are being destroyed; otherwise returns false.

See also:
  `startingUp()`.

### exec

    public static int exec()

  Enters the main event loop and waits until `exit()` is called. Returns the value that was set to `exit()` (which is 0 if `exit()` is called via `quit()`).

  It is necessary to call this function to start event handling. The main event loop receives events from the window system and dispatches these to the application widgets.

  To make your application perform idle processing (i.e. executing a special function whenever there are no pending events), use a `QTimer` with 0 timeout. More advanced idle processing schemes can be achieved using `processEvents()`.

See also:
  `quit()`, `exit()`, `processEvents()`, and `QApplication::exec()`.

### exit

    public static void exit()

  Tells the application to exit with a return code.

  After this function has been called, the application leaves the main event loop and returns from the call to `exec()`. The `exec()` function returns `returnCode`. If the event loop is not running, this function does nothing.

  By convention, a `returnCode` of 0 means success, and any non-zero value indicates an error.

  Note that unlike the C library function of the same name, this function does return to the caller -- it is event processing that stops.

See also:
  `quit()`, and `exec()`.

### exit

    public static void exit(int retcode)

  Tells the application to exit with a return code.

  After this function has been called, the application leaves the main event loop and returns from the call to `exec()`. The `exec()` function returns `returnCode`. If the event loop is not running, this function does nothing.

  By convention, a `returnCode` of 0 means success, and any non-zero value indicates an error.

  Note that unlike the C library function of the same name, this function does return to the caller -- it is event processing that stops.

See also:
  `quit()`, and `exec()`.

### flush

    public static void flush()

  Flushes the platform specific event queues.

  If you are doing graphical changes inside a loop that does not return to the event loop on asynchronous window systems like X11 or double buffered window systems like Mac OS X, and you want to visualize these changes immediately (e.g. Splash Screens), call this function.

See also:
  `sendPostedEvents()`.

### hasPendingEvents

    public static boolean hasPendingEvents()

  This function returns true if there are pending events; otherwise returns false. Pending events can be either from the window system or posted events using `postEvent()`.

See also:
  `QAbstractEventDispatcher::hasPendingEvents()`.

### installTranslator

    public static void installTranslator(QTranslator messageFile)

  Adds the translation file `translationFile` to the list of translation files to be used for translations.

  Multiple translation files can be installed. Translations are searched for in the last installed translation file on, back to the first installed translation file. The search stops as soon as a matching translation is found.

  Installing or removing a `QTranslator`, or changing an installed `QTranslator` generates a `LanguageChange` event for the `QCoreApplication` instance. A `QApplication` instance will propagate the event to all toplevel windows, where a reimplementation of changeEvent can re-translate the user interface by passing user-visible strings via the tr() function to the respective property setters. User-interface classes generated by Qt Designer provide a `retranslateUi()` function that can be called.

See also:
  `removeTranslator()`, `translate()`, `QTranslator::load()`, and Dynamic Translation.

### instance

    public static QCoreApplication instance()

  Returns a pointer to the application's `QCoreApplication` (or `QApplication`) instance.

### libraryPaths

    public static java.util.List libraryPaths()

  Returns a list of paths that the application will search when dynamically loading libraries.

  Qt provides default library paths, but they can also be set using a qt.conf file. Paths specified in this file will override default values.

  This list will include the installation directory for plugins if it exists (the default installation directory for plugins is `INSTALL/plugins`, where `INSTALL` is the directory where Qt was installed). The directory of the application executable (NOT the working directory) is always added, as well as the colon separated entries of the QT_PLUGIN_PATH environment variable.

  If you want to iterate over the list, you can use the foreach pseudo-keyword:

              for (String path : QApplication.libraryPaths())
                  do_something(path);

See also:
  `setLibraryPaths()`, `addLibraryPath()`, `removeLibraryPath()`, QLibrary, and How to Create Qt Plugins.

### organizationDomain

    public static java.lang.String organizationDomain()

  This property holds the Internet domain of the organization that wrote this application. The value is used by the `QSettings` class when it is constructed using the empty constructor. This saves having to repeat this information each time a `QSettings` object is created.

  On Mac, `QSettings` uses `organizationDomain()` as the organization if it's not an empty string; otherwise it uses `organizationName()`. On all other platforms, `QSettings` uses `organizationName()` as the organization.

See also:
  `organizationName`, `applicationName`, and `applicationVersion`.

### organizationName

    public static java.lang.String organizationName()

  This property holds the name of the organization that wrote this application. The value is used by the `QSettings` class when it is constructed using the empty constructor. This saves having to repeat this information each time a `QSettings` object is created.

  On Mac, `QSettings` uses `organizationDomain()` as the organization if it's not an empty string; otherwise it uses `organizationName()`. On all other platforms, `QSettings` uses `organizationName()` as the organization.

See also:
  `organizationDomain`, and `applicationName`.

### postEvent

    public static void postEvent(QObject receiver,
                                 QEvent event)

  Adds the event `event`, with the object `receiver` as the receiver of the event, to an event queue and returns immediately.

  The event must be allocated on the heap since the post event queue will take ownership of the event and delete it once it has been posted. It is not safe to modify or delete the event after it has been posted.

  When control returns to the main event loop, all events that are stored in the queue will be sent using the `notify()` function.

  Events are processed in the order posted. For more control over the processing order, use the `postEvent()` overload below, which takes a priority argument. This function posts all event with a `Qt::NormalEventPriority` .

See also:
  `sendEvent()`, `notify()`, and `sendPostedEvents()`.

### postEvent

    public static void postEvent(QObject receiver,
                                 QEvent event,
                                 int priority)

  Adds the event `event`, with the object `receiver` as the receiver of the event, to an event queue and returns immediately.

  The event must be allocated on the heap since the post event queue will take ownership of the event and delete it once it has been posted. It is not safe to modify or delete the event after it has been posted.

  When control returns to the main event loop, all events that are stored in the queue will be sent using the `notify()` function.

  Events are sorted in descending `priority` order, i.e. events with a high `priority` are queued before events with a lower `priority`. The `priority` can be any integer value, i.e. between INT_MAX and INT_MIN, inclusive; see `Qt::EventPriority` for more details. Events with equal `priority` will be processed in the order posted.

See also:
  `sendEvent()`, `notify()`, `sendPostedEvents()`, and `Qt::EventPriority` .

### processEvents

    public static void processEvents(QEventLoop.ProcessEventsFlag[] flags)

  Processes all pending events for the calling thread according to the specified `flags` until there are no more events to process.

  You can call this function occasionally when your program is busy performing a long operation (e.g. copying a file).

  In event you are running a local loop which calls this function continuously, without an event loop, the `DeferredDelete` events will not be processed. This can affect the behaviour of widgets, e.g. `QToolTip`, that rely on `DeferredDelete` events to function properly. An alternative would be to call `sendPostedEvents()` from within that local loop.

  Calling this function processes events only for the calling thread.

See also:
  `exec()`, `QTimer`, `QEventLoop::processEvents()`, `flush()`, and `sendPostedEvents()`.

### processEvents

    public static void processEvents()

  Processes all pending events for the calling thread according to the specified `flags` until there are no more events to process.

  You can call this function occasionally when your program is busy performing a long operation (e.g. copying a file).

  In event you are running a local loop which calls this function continuously, without an event loop, the `DeferredDelete` events will not be processed. This can affect the behaviour of widgets, e.g. `QToolTip`, that rely on `DeferredDelete` events to function properly. An alternative would be to call `sendPostedEvents()` from within that local loop.

  Calling this function processes events only for the calling thread.

See also:
  `exec()`, `QTimer`, `QEventLoop::processEvents()`, `flush()`, and `sendPostedEvents()`.

### processEvents

    public static void processEvents(QEventLoop.ProcessEventsFlags flags)

  Processes all pending events for the calling thread according to the specified `flags` until there are no more events to process.

  You can call this function occasionally when your program is busy performing a long operation (e.g. copying a file).

  In event you are running a local loop which calls this function continuously, without an event loop, the `DeferredDelete` events will not be processed. This can affect the behaviour of widgets, e.g. `QToolTip`, that rely on `DeferredDelete` events to function properly. An alternative would be to call `sendPostedEvents()` from within that local loop.

  Calling this function processes events only for the calling thread.

See also:
  `exec()`, `QTimer`, `QEventLoop::processEvents()`, `flush()`, and `sendPostedEvents()`.

### processEvents

    public static void processEvents(QEventLoop.ProcessEventsFlags flags,
                                     int maxtime)

  Processes pending events for the calling thread for `maxtime` milliseconds or until there are no more events to process, whichever is shorter.

  You can call this function occasionally when you program is busy doing a long operation (e.g. copying a file).

  Calling this function processes events only for the calling thread.

See also:
  `exec()`, `QTimer`, and `QEventLoop::processEvents()`.

### quit

    public static void quit()

  Tells the application to exit with return code 0 (success). Equivalent to calling QCoreApplication::exit(0).

  It's common to connect the `QApplication::lastWindowClosed()` signal to `quit()`, and you also often connect e.g. `QAbstractButton::clicked()` or signals in `QAction`, `QMenu`, or `QMenuBar` to it.

  Example:

              QPushButton quitButton = new QPushButton("Quit");
              quitButton.clicked.connect(QApplication.instance(), "quit()");

See also:
  `exit()`, `aboutToQuit()` , and `QApplication::lastWindowClosed()` .

### removeLibraryPath

    public static void removeLibraryPath(java.lang.String arg__1)

  Removes `path` from the library path list. If `path` is empty or not in the path list, the list is not changed.

See also:
  `addLibraryPath()`, `libraryPaths()`, and `setLibraryPaths()`.

### removePostedEvents

    public static void removePostedEvents(QObject receiver)

  Removes all events posted using `postEvent()` for `receiver`.

  The events are not dispatched, instead they are removed from the queue. You should never need to call this function. If you do call it, be aware that killing events may cause `receiver` to break one or more invariants.

### removePostedEvents

    public static void removePostedEvents(QObject receiver,
                                          int eventType)

  Removes all events of the given `eventType` that were posted using `postEvent()` for `receiver`.

  The events are not dispatched, instead they are removed from the queue. You should never need to call this function. If you do call it, be aware that killing events may cause `receiver` to break one or more invariants.

  If `receiver` is null, the events of `eventType` are removed for all objects. If `eventType` is 0, all the events are removed for `receiver`.

### removeTranslator

    public static void removeTranslator(QTranslator messageFile)

  Removes the translation file `translationFile` from the list of translation files used by this application. (It does not delete the translation file from the file system.)

See also:
  `installTranslator()`, `translate()`, and QObject::tr().

### sendEvent

    public static boolean sendEvent(QObject receiver,
                                    QEvent event)

  Sends event `event` directly to receiver `receiver`, using the `notify()` function. Returns the value that was returned from the event handler.

  The event is not deleted when the event has been sent. The normal approach is to create the event on the stack, for example:

              QMouseEvent event = new QMouseEvent(QEvent.Type.MouseButtonPress, pos, Qt.MouseButton.NoButton,
                                                  new Qt.MouseButtons(Qt.MouseButton.NoButton),
                                                  new Qt.KeyboardModifiers(Qt.KeyboardModifier.NoModifier));
              QApplication.sendEvent(mainWindow, event);

See also:
  `postEvent()`, and `notify()`.

### sendPostedEvents

    public static void sendPostedEvents()

  Dispatches all posted events, i.e. empties the event queue.

### sendPostedEvents

    public static void sendPostedEvents(QObject receiver,
                                        int event_type)

  Immediately dispatches all events which have been previously queued with `QCoreApplication::postEvent()` and which are for the object `receiver` and have the event type `event_type`.

  Events from the window system are not dispatched by this function, but by `processEvents()`.

  If `receiver` is null, the events of `event_type` are sent for all objects. If `event_type` is 0, all the events are sent for `receiver`.

  Note: This method must be called from the same thread as its `QObject` parameter, `receiver`.

See also:
  `flush()`, and `postEvent()`.

### setApplicationName

    public static void setApplicationName(java.lang.String application)

  This property holds the name of this application. The value is used by the `QSettings` class when it is constructed using the empty constructor. This saves having to repeat this information each time a `QSettings` object is created.

See also:
  `organizationName`, `organizationDomain`, and `applicationVersion`.

### setApplicationVersion

    public static void setApplicationVersion(java.lang.String version)

  This property holds the version of this application.

See also:
  `applicationName`, `organizationName`, and `organizationDomain`.

### setAttribute

    public static void setAttribute(Qt.ApplicationAttribute attribute)

  Sets the attribute `attribute` if `on` is true; otherwise clears the attribute.

  One of the attributes that can be set with this method is `Qt::AA_ImmediateWidgetCreation` . It tells Qt to create toplevel windows immediately. Normally, resources for widgets are allocated on demand to improve efficiency and minimize resource usage. Therefore, if it is important to minimize resource consumption, do not set this attribute.

See also:
  `testAttribute()`.

### setAttribute

    public static void setAttribute(Qt.ApplicationAttribute attribute,
                                    boolean on)

  Sets the attribute `attribute` if `on` is true; otherwise clears the attribute.

  One of the attributes that can be set with this method is `Qt::AA_ImmediateWidgetCreation` . It tells Qt to create toplevel windows immediately. Normally, resources for widgets are allocated on demand to improve efficiency and minimize resource usage. Therefore, if it is important to minimize resource consumption, do not set this attribute.

See also:
  `testAttribute()`.

### setLibraryPaths

    public static void setLibraryPaths(java.util.List arg__1)

  Sets the list of directories to search when loading libraries to `paths`. All existing paths will be deleted and the path list will consist of the paths given in `paths`.

See also:
  `libraryPaths()`, `addLibraryPath()`, `removeLibraryPath()`, and QLibrary.

### setOrganizationDomain

    public static void setOrganizationDomain(java.lang.String orgDomain)

  This property holds the Internet domain of the organization that wrote this application. The value is used by the `QSettings` class when it is constructed using the empty constructor. This saves having to repeat this information each time a `QSettings` object is created.

  On Mac, `QSettings` uses `organizationDomain()` as the organization if it's not an empty string; otherwise it uses `organizationName()`. On all other platforms, `QSettings` uses `organizationName()` as the organization.

See also:
  `organizationName`, `applicationName`, and `applicationVersion`.

### setOrganizationName

    public static void setOrganizationName(java.lang.String orgName)

  This property holds the name of the organization that wrote this application. The value is used by the `QSettings` class when it is constructed using the empty constructor. This saves having to repeat this information each time a `QSettings` object is created.

  On Mac, `QSettings` uses `organizationDomain()` as the organization if it's not an empty string; otherwise it uses `organizationName()`. On all other platforms, `QSettings` uses `organizationName()` as the organization.

See also:
  `organizationDomain`, and `applicationName`.

### startingUp

    public static boolean startingUp()

  Returns true if an application object has not been created yet; otherwise returns false.

See also:
  `closingDown()`.

### testAttribute

    public static boolean testAttribute(Qt.ApplicationAttribute attribute)

  Returns true if attribute `attribute` is set; otherwise returns false.

See also:
  `setAttribute()`.

### translate

    public static java.lang.String translate(java.lang.String context,
                                             java.lang.String sourceText,
                                             java.lang.String comment)

  Returns the translation text for `sourceText`, by querying the installed translation files. The translation files are searched from the most recently installed file back to the first installed file.

  QObject.tr() and QObject.trUtf8() provide this functionality more conveniently.

  `context` is typically a class name (e.g., "MyDialog") and `sourceText` is either English text or a short identifying text.

  `comment` is a disambiguating comment, for when the same `sourceText` is used in different roles within the same context. By default, it is null. `encoding` indicates the 8-bit encoding of character stings See the QTranslator documentation for more information about contexts and comments.

### translate

    public static java.lang.String translate(java.lang.String context,
                                             java.lang.String sourceText)

  This is an overloaded function provided for convenience.

### translate

    public static java.lang.String translate(java.lang.String context,
                                             java.lang.String sourceText,
                                             java.lang.String comment,
                                             int n)

  Returns the translation text for `sourceText`, by querying the installed translation files. The translation files are searched from the most recently installed file back to the first installed file.

  QObject.tr() and QObject.trUtf8() provide this functionality more conveniently.

  `context` is typically a class name (e.g., "MyDialog") and `sourceText` is either English text or a short identifying text.

  `comment` is a disambiguating comment, for when the same `sourceText` is used in different roles within the same context. By default, it is null. `encoding` indicates the 8-bit encoding of character stings See the QTranslator documentation for more information about contexts and comments.

  `n` is used in conjunction with %n to support plural forms. See QObject.tr() for details.

### initialize

    public static void initialize(java.lang.String[] args)

  QCoreApplication keeps a unique instance of a QCoreApplication. It is initialized with this function.

### invokeLater

    public static void invokeLater(java.lang.Runnable runnable)

  This function will queue the `runnable` and invokes it later.

### invokeAndWait

    public static void invokeAndWait(java.lang.Runnable runnable)

  Executes the runnable's run() method in the main thread and waits for it to return. If the current thread is not the main thread, an event loop must be running in the main thread, or this method will wait indefinitely.

### invokeLater

    public static void invokeLater(int timeout,
                                   java.lang.Runnable task)

  Executes the task in the application's main thread after the specified timeout. This is done by starting a timer so this method does not block.

  Parameters:
    `timeout` - The time to wait, in milliseconds
    `task` - The task to perform...

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD